/*
    Copyright (c) 2010 digitalSTROM.org, Zurich, Switzerland

    Author: Sergey 'Jin' Bostandzhyan <jin@mediatomb.cc> 

    This file is part of upnp-beacon.

    upnp-beacon is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as 
    published by the Free Software Foundation.

    upnp-beacon is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with upnp-beacon. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef __UPNP_BEACON_DEVICE_DESC_H__
#define __UPNP_BEACON_DEVICE_DESC_H__

typedef struct desc_config_t 
{
    const char *friendly_name;
    const char *manufacturer;
    const char *manufacturer_url;
    const char *modeldesc;
    const char *modelname;
    const char *udn;
    const char *url;
    char *ip;
    const char *protocol;
    const char *port;
} desc_config_t;

/// \brief Generates device description document for a root device without
/// any services, that can be used to register a device using libupnp.
/// 
/// \param config structure containing device parameters
/// \return zero terminated buffer containing the document, must be freed by 
/// the caller
char *device_desc_from_config(const desc_config_t *config);

#endif

